/* Programme de dmonstration de la liaison srie
 
	Fichier 		: RS232.C
	Projet  		: RS232.MCP
	Compilateur 	: MPLAB C18
	date 			: 01/02/2006
 	Auteur		: Philippe Lucidarme (philippe.lucidarme@univ-angers.fr)
	Cible 			: PIC18F452 
   	Carte			: CNC Micro
	Quartz		: 20 MHz
 	
	Rsum		: programme de dmonstration de la liaison srie
	
	descritpion		: ce programme reoit un caractre depuis la liaison srie.
	Si c'est une lettre de l'alphabet en minuscule, le programme la cenvertie en 
	majuscule et la renvoie sur la liaison srie.


*/

//************************** fichier d'entete **********************************/

#include <p18f452.h>		// Pour les registres du PIC18F452
#include <usart.h>			// Pour le priphrique USART qui gre la liaison srie

//************ Instruction de configuration du pic et de l'horloge *************/

#pragma config WDT = OFF	// Pas de  watchdog
#pragma config OSC = HS		// Quartz HS pour un quartz 20MHz

//****************************debut du programme********************************/

void main(void)				// Programme principal
{		
	char ch=0;				// Caractre qui sera reu sur la liaison srie
	
	// Configure tous les ports en entre (1 = input / 0 = output)

	TRISA = 0b11111111;		// XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX
	TRISB = 0b11111111;		// XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX
	TRISC = 0b10111111;		// RX 	| TX	     | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX
	TRISD = 0b11111111;		// XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX | XXXXXX
	TRISE = 0b111;			// XXXXXX | XXXXXX | XXXXXX
	
	// Configure la liaison srie :

	OpenUSART	(	USART_TX_INT_OFF	&	// Pas d'interruption sur l'mission
					USART_RX_INT_OFF	&	// Pas d'interruption sur la rception
					USART_ASYNCH_MODE	&	// Mode asynchrone
					USART_EIGHT_BIT		& 	// Transmission sur 8 bits (1 octet)
					USART_CONT_RX		&	// Reception continue
					USART_BRGH_HIGH		,	// Haute vitesse
					10);					// (20e6 - 115200) / (16 * 115200)
	
	// Transmissions sur la liaison srie
	
	while (1)									// Boucle infinie
	{	
		if (DataRdyUSART())						// Attends la prsence d'un caractre sur la liaison srie
		{
			ch=ReadUSART();						// Lit le caractre
			if ((ch>=97) && (ch<=122)) ch-=32;	// Convertie le caractre en minuscule si c'est une lettre minuscule
			WriteUSART(ch);						// Renvoie le caractre aprs traitement
		}
	}

	CloseUSART();								// Ferme proprement la liaison srie
}





